//+------------------------------------------------------------------+
//|                                               ColoredVolumes.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, TheXpert"
#property link      "http://trend-lab.blogspot.com/"

extern string Ticker = "AUTO";

#property indicator_separate_window

#property indicator_buffers 2

#property indicator_color1 SeaGreen
#property indicator_color2 Salmon

#property indicator_width1 2
#property indicator_width2 2

#property indicator_minimum 0

double Vol[];
double Desc[];

bool FirstRun;

datetime LastAvailable = 0;

int init()
{
   SetIndexBuffer(0, Vol);
   SetIndexBuffer(1, Desc);
   
   SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexStyle(1, DRAW_HISTOGRAM);

   FirstRun = true;
}

int start()
{
   if (FirstRun)
   {
      ArrayInitialize(Vol, EMPTY_VALUE);
      ArrayInitialize(Desc, EMPTY_VALUE);
      
      FirstRun = false;
   }
   
   int toCount = Bars - IndicatorCounted();
   int shift = iBarShift(Symbol(), Period(), LastAvailable) + 1;
   if (shift > toCount) toCount = shift;
   
   for (int i = toCount - 1; i >= 0; i--)
   {
      double v = iCustom(Symbol(), 0, "ClusterX_Volume", Ticker, 0, i);
      
      if (v == EMPTY_VALUE)
      {
         continue;
      }
      
      LastAvailable = Time[i];

      Vol[i] = v;
      if (Vol[i + 1] > v && Vol[i + 1] != EMPTY_VALUE)   Desc[i] = v;
      else                                               Desc[i] = 0;
   }
   
   return(0);
}